var appId = 'com.junecloud.widget.plus';
var thisVersion;
var readableVersion;
var currentVersion;
var dismissDays = 30;
var downloadUrl = 'http://junecloud.com/software/mac/plus.html';

var thePath = 'file:///Library/Widgets/Stickies.wdgt';
var defaultPath = thePath;
var theImage = 'images/Plus.png';
var defaultImage = theImage;
var imageName = 'Plus (Default)';
var defaultImageName = imageName;
var theSize = 32;
var maxSize = 256;
var minSize = 32;
var relativeSize = false;
var glowTimer;
var inSettings = false;
var sizeChecker;
var previewSizeChecker;
var createdImages = new Array();
var imageCount = 0;
var xmlRequest;
var keyPressSet = false;
var doFlip = false;

function setup () {

	if (typeof Plus == 'undefined') {
		window.resizeTo(320,420);
		document.body.className = 'unsupported';
		$('unsupported').innerHTML = translate('Plus requires Mac OS X 10.5 or later.');
		return;
	}

	var infobutton = new AppleInfoButton ($('infobutton'),
		$('settings'),'white','white',fadeSettingsOut);

	getCurrentVersion();
	$('version').innerText = 'Plus '+readableVersion;

	if (window.widget) {

		var settingsDone = new AppleGlassButton($('settingsdone'),translate('Done'),saveSettings);
		var aboutDone = new AppleGlassButton($('aboutdone'),translate('Done'),fadeAboutOut);

		var showSettings = false;
		if (getPath()) {
			updateWidget();
		} else showSettings = true;

		if (showSettings) {
			editSettings(false);
			$('droptip').style.display = 'block';
		} else {
			adjustSize(false);
			setImage();
		}

		widget.onremove = deleteSettings;
		setTimeout(function(){
			widget.onshow = showWidget;
		},1000);

	}
	checkVersion(7);

}

function getPath () {
	return widget.preferenceForKey(widget.identifier+'-path');
}

function updateWidget ( thisPath ) {
	thePath = getPath();
	if (widget.preferenceForKey(widget.identifier+'-image')) {
		theImage = widget.preferenceForKey(widget.identifier+'-image');
		if (widget.preferenceForKey(widget.identifier+'-imagename')) imageName = widget.preferenceForKey(widget.identifier+'-imagename');
		if (widget.preferenceForKey(widget.identifier+'-size')) theSize = widget.preferenceForKey(widget.identifier+'-size');
	}
	if (widget.preferenceForKey(widget.identifier+'-relative')) relativeSize = widget.preferenceForKey(widget.identifier+'-relative');
	$('relativesetting').checked = relativeSize;
}

function showWidget () {
	var thisPath = getPath();
	// TODO: do I need to check the other settings as well?!
	if (thisPath && thisPath != thePath) {
		updateWidget();
		closeSettings();
	}
}

function adjustSize (useMinimum) {

	var thisWidth = $('plus').width;
	var thisHeight = $('plus').height;
	if (useMinimum) {
		if (thisWidth < 320) thisWidth = 320;
		if (thisHeight < 420) thisHeight = 420;
	}
	window.resizeTo(thisWidth,thisHeight);

}

function setKeyPress () {
	if (!keyPressSet) {
		document.onkeypress = keypress;
		keyPressSet = false;
	}
}

function newWidget () {
	if (window.widget && thePath) {
		if (thePath.match(/\/Library\/Widgets\//)) {
			var theCommand = '/usr/bin/open '+thePath;
			widget.system(theCommand,null);
		} else widget.openURL(thePath);
	}
}

function setImage () {
	var timeString = (theImage.match(/^data:/)) ? '' : '?'+(new Date().getTime());
	$('plus').src = theImage+timeString;
	sizeChecker = new Image();
	sizeChecker.onload = function () { 
		setSize('plus',theSize);
		setKeyPress();
	};
	sizeChecker.onerror = function () {
		theImage = defaultImage;
		editSettings();
	}
	sizeChecker.src = theImage+timeString;
}

function setPreview (thisImage) {
	var timeString = (thisImage.match(/^data:/)) ? '' : '?'+(new Date().getTime());
	$('imagedisplay').style.display = 'none';

	$('imagedisplay').src = thisImage+timeString;
	previewSizeChecker = new Image();
	previewSizeChecker.onload = function () {
		setSize('imagedisplay',$('sizeslider').value);
		$('imagedisplay').style.display = 'inline';
	};
	previewSizeChecker.src = thisImage+timeString;
}

function toggleRelative (theValue) {
	relativeSize = theValue;
	if (window.widget) widget.setPreferenceForKey(relativeSize,widget.identifier+'-relative');
	if (sizeChecker) setSize('plus',theSize);
}

function setSize (theId,thisSize) {

	var theScale = thisSize/maxSize;
	var fullWidth = (theId == 'plus') ? sizeChecker.width : previewSizeChecker.width;
	var fullHeight = (theId == 'plus') ? sizeChecker.height : previewSizeChecker.height;

	if (!relativeSize || theId != 'plus') {
		var showRelative = false;
		if (fullWidth > maxSize) {
			fullHeight = fullHeight * (maxSize/fullWidth);
			fullWidth = maxSize;
			showRelative = true;
		}
		if (fullHeight > maxSize) {
			fullWidth = fullWidth * (maxSize/fullHeight);
			fullHeight = maxSize;
			showRelative = true;
		}
		$('relative').style.display = (showRelative) ? 'block' : 'none';
	}
	while (fullWidth * theScale < minSize && theScale < 1) theScale += 0.05;

	var thisWidth = fullWidth * theScale;
	var thisHeight = fullHeight * theScale;
	$(theId).width = thisWidth;
	$(theId).height = thisHeight;

	if (theId == 'plus') {
		if (doFlip) {
			if (window.widget) widget.prepareForTransition('ToFront');
			$('settings').style.display = 'none';
			$('plus').style.display = 'block';
			clearMenu('opensetting');
			clearMenu('imagesetting');
			setTimeout(finishFlipToFront,0);
			doFlip = false;
		} else if (!inSettings) {
			adjustSize(false);
			$('plus').style.display = 'block';
		} else adjustSize(true);
	}

}

function finishFlipToFront () {
	if (window.widget) widget.performTransition();
	setTimeout('adjustSize(false)',1000);
}

function dragdrop (event) {
	event.stopPropagation();
	event.preventDefault();

	if (fadeId == 'about') fadeAboutOut();
	if (window.widget) {
		var newPath = null;
		try {
			newPath = event.dataTransfer.getData('text/uri-list');
		} catch (ex) { }
		if (newPath) {
			newPath = newPath.split("\n");
			pathCount = newPath.length;

			// When the first image is dropped, start it at full size
			if ($('imagesetting').value == defaultImage &&
				$('sizeslider').value == 32) {
				$('sizeslider').value = theSize = 256;
			}

			for (var i = 0; i < pathCount; i++) editSettings(newPath[i]);
		} else editSettings();
	}
	
	glowOff();
}

function editSettings ( newPath ) {
	if (Plus) {
		var newImage = '';
		var isImage = false;
		if (newPath) {
			var theName = nameFromPath(unescape(newPath));
			var theExt = Plus.extFromPath(unescape(newPath));

			if (newPath.match(/^file:\/\/(localhost)?\//)) {
				filePath = unescape(newPath.replace(/^file:\/\/(localhost)?\//,'/'));
				var imageId = widget.identifier+'-'+imageCount;
				imageCount++;
				newImage = Plus.imageFromPath(filePath,imageId);
				if (newImage) {
					newImage = 'data:image/png;base64,'+newImage;					
					$('droptip').style.display = 'none';
					createdImages.push(newImage);
					isImage = true;
				}
			} else if (Plus.pathIsImage(newPath)) {
				newImage = newPath;
				$('droptip').style.display = 'none';
				isImage = true;
			}
		}
	
		if (!inSettings) {
			$('sizeslider').value = theSize;
		
			var oldPath = nameFromPath(unescape(thePath));
			var oldImage = imageName;

			addOption('open','','None',true);
			addOption('open',thePath,oldPath,true);
			addOption('image',defaultImage,defaultImageName,true);
			addOption('image',theImage,oldImage,true);
		}
	
		if (newPath) {
			var selectThis = (isImage && $('opensetting').value != defaultPath) ? false : true;
			addOption('open',newPath,theName,selectThis);
			if (newImage) addOption('image',newImage,theName,true);
		}
	
		if (!inSettings) {
			adjustSize(true);
			if (window.widget) widget.prepareForTransition('ToBack');
			$('plus').style.display = 'none';
			$('settings').style.display = 'block';
			if (window.widget) setTimeout('widget.performTransition()',0);
		}
	
		inSettings = true;
	}
	setKeyPress();
}

function nameFromPath ( thePath ) {
	var theName = '';
	if (thePath.match(/^file:\/\/(localhost)?\//)) {
		theName = Plus.nameFromPath(thePath);
	} else theName = thePath.replace(/(^[a-z]+:\/\/|\/$)/g,'');
	return theName;
}

function saveSettings ( ) {
	theImage = $('imagesetting').value;
	imageName = $('imagesetting').options[$('imagesetting').selectedIndex].innerHTML;
	thePath = $('opensetting').value;
	theSize = $('sizeslider').value;

	closeSettings();

	if (window.widget) {
		widget.setPreferenceForKey(thePath,widget.identifier+'-path');
		widget.setPreferenceForKey(theImage,widget.identifier+'-image');
		widget.setPreferenceForKey(imageName,widget.identifier+'-imagename');
		widget.setPreferenceForKey(theSize,widget.identifier+'-size');
	}
}

function closeSettings ( ) {
	createdImages = new Array();
	doFlip = true;
	setImage();
	inSettings = false;
}

function deleteSettings ( ) {
	widget.setPreferenceForKey(null,widget.identifier+'-path');
	widget.setPreferenceForKey(null,widget.identifier+'-image');
	widget.setPreferenceForKey(null,widget.identifier+'-imagename');
	widget.setPreferenceForKey(null,widget.identifier+'-size');
	widget.setPreferenceForKey(null,widget.identifier+'-relative');
}

function trim (theString) {
	return theString.replace(/^\s+/,'').replace(/\s+$/,'');
}

function addOption ( theId, theValue, theText, isSelected ) {

	var optExists = false;
	var theOptions = $(theId+'setting').options;
	optCount = theOptions.length;
	for (var i = 0; i < optCount; i++) {
		if (theOptions[i].value == theValue) optExists = true;
	}
	if (!optExists) {
		var newOption;
		newOption = document.createElement('option');
		newOption.value = theValue;
		if (isSelected) {
			newOption.selected = true;
			$(theId+'text').innerHTML = theText;
			if (theId == 'image') setPreview(theValue);
		}
		newOption.appendChild(document.createTextNode(theText));
		$(theId+'setting').appendChild(newOption);
	}

}

function clearMenu ( theId ) {
	while (theChild = $(theId).children(0)) {
		$(theId).removeChild(theChild);
	}
}

function updateMenu ( theId ) {
	var menuObj = $(theId+'setting');
	$(theId+'text').innerHTML = menuObj.options[menuObj.selectedIndex].innerHTML;
	if (theId == 'image') setPreview(menuObj.value);
}

function getExt ( thePath ) {
	var theExt = thePath.split('.').pop();
	if (theExt) theExt = theExt.toLowerCase();
}

function dragenter (event) {
	glowOn();	
	event.stopPropagation();
	event.preventDefault();
}
function dragover (event) {
	glowOn();	
	event.stopPropagation();
	event.preventDefault();
}
function dragleave (event) {
	glowTimer = setTimeout(glowOff,100);
	event.stopPropagation();
	event.preventDefault();
}

function glowOn () {
	clearTimeout(glowTimer);
	if (theImage == 'images/Plus.png') $('plus').src = 'images/Plus-glow.png';
}
function glowOff () {
	if (theImage == 'images/Plus.png') $('plus').src = 'images/Plus.png';
}
function mousedown () {
	if (theImage == 'images/Plus.png') $('plus').src = 'images/Plus-down.png';
}
function mouseup () {
	if (theImage == 'images/Plus.png') $('plus').src = 'images/Plus.png';
}

function keypress (event) {
	var theKey = String.fromCharCode(event.which);
	if (theKey == '+' || theKey == '=') {
		editSettings(false);
	} else if (event.which == 13 && inSettings) {
		if (fadeId == 'about') {
			fadeAboutOut();
		} else saveSettings();
	}
}

// Fade about screen in and out

var fadeId = 'settings';
var currentOpacity;
var opacityStep;
var doneAction = false;
var fadeTimer;

function fadeSettingsOut () {

	fadeId = 'settings';
	currentOpacity = 1;
	opacityStep = -0.1;
	doneAction = fadeAboutIn;
	adjustOpacity();
	
}
function fadeAboutIn () {

	$('settings').style.display = 'none';
	$('aboutfade').style.opacity = 0;
	$('about').style.display = 'block';

	fadeId = 'about';
	currentOpacity = 0;
	opacityStep = 0.1;
	doneAction = false;
	adjustOpacity();
	
}
function fadeAboutOut () {

	fadeId = 'about';
	currentOpacity = 1;
	opacityStep = -0.1;
	doneAction = fadeSettingsIn;
	adjustOpacity();
	
}
function fadeSettingsIn () {

	$('about').style.display = 'none';
	$('settingsfade').style.opacity = 0;
	$('settings').style.display = 'block';

	fadeId = 'settings';
	currentOpacity = 0;
	opacityStep = 0.1;
	doneAction = false;
	adjustOpacity();
	
}

function adjustOpacity () {

	currentOpacity = currentOpacity + opacityStep;
	if (opacityStep < 0) {
		if (currentOpacity < 0) currentOpacity = 0;
	} else if (currentOpacity > 1) currentOpacity = 1;
	$(fadeId+'fade').style.opacity = currentOpacity;
	if ((opacityStep < 0 && currentOpacity == 0) || (opacityStep > 0 && currentOpacity == 1)) {
		if (doneAction) fadeTimer = window.setTimeout(doneAction,20);
	} else fadeTimer = window.setTimeout(adjustOpacity,20);

}


// version checking


function getCurrentVersion () {

	var request = new XMLHttpRequest();
	request.open('GET','Info.plist',false);
	request.send();

	var nodes = request.responseXML.getElementsByTagName('dict')[0].childNodes;
	var nodeLength = nodes.length;
	for (var i = 0; i < nodeLength; i++) {
		if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase() == 'key') {
			if (nodes[i].firstChild.data == 'CFBundleShortVersionString') {
				readableVersion = nodes[i+2].firstChild.data;
			} else if (nodes[i].firstChild.data == 'CFBundleVersion') {
				var result = nodes[i+2].firstChild.data;
				result = result.replace(/([0-9]+)\.([0-9]+)\.([0-9]+)/,'$1.$2$3');
				thisVersion = currentVersion = parseFloat(result);				
			}
		} 
	} 

}

function checkVersion (theDays,skipDismissed) {

	var lastVersionCheck = (widget.preferenceForKey('lastversioncheck')) ? 
		widget.preferenceForKey('lastversioncheck') : 0;
	var dismissedUpdate = (widget.preferenceForKey('dismissedupdate')) ? 
		widget.preferenceForKey('dismissedupdate') : 0;
	var currentTime = (new Date()).getTime();

	if (skipDismissed || !dismissedUpdate || dismissedUpdate + (86400000 * dismissDays) < currentTime) {
		if (lastVersionCheck + (86400000 * theDays) < currentTime) {
			checkVersionNow();
		} else {
			currentVersion = (widget.preferenceForKey('currentversion')) ? 
				parseFloat(widget.preferenceForKey('currentversion')) : thisVersion;
			if (currentVersion > thisVersion) showUpdateBadge();
		}
	}

}

function checkVersionNow () {

	alert('Checking for a new version of Plus');

	xmlRequest = new XMLHttpRequest();
	xmlRequest.onload = getVersion;
	xmlRequest.open('POST','http://junecloud.com/software/mac/version.php');
	xmlRequest.send('id='+appId);

}

function getVersion () {

	widget.setPreferenceForKey((new Date()).getTime(),'lastversioncheck');

	if (this.status == 200 && this.responseXML) {
		for (var child = this.responseXML.firstChild; child != null; child = child.nextSibling) {
			if (child.nodeName == 'versionstatus') {
				var itemlist = child;
				for (var item = itemlist.firstChild; item != null; item = item.nextSibling) {
					if (item.nodeName == 'version') {
						currentVersion = parseFloat(item.getAttribute('value'));
						widget.setPreferenceForKey(currentVersion,'currentversion');
					} else if (item.nodeName == 'download') {
						downloadUrl = item.getAttribute('value');
					}
				}
				break;
			}
		}
	}

	if (currentVersion > thisVersion) showUpdateBadge();
	return;

}

function showUpdateBadge () {
	$('getupdate').href = downloadUrl;
	$('getupdate').title = translate('A new version of Plus is available! Click here to download it.');
	$('droptip').style.display = 'none';
	$('updatebox').style.display = 'block';
}

function dismissUpdate () {
	widget.setPreferenceForKey((new Date()).getTime(),'dismissedupdate');
	$('updatebox').style.display = 'none';
}


// misc


function $ (id) {
	return document.getElementById(id);
}

function translate (key) {
	try {
		var ret = translation[key];
		if (ret === undefined) ret = key;
		return ret;
	} catch (ex) { }
	return key;
}

function openSite (theUrl) {
	if (window.widget) widget.openURL(theUrl);
	return false;
}